\begin{tikzpicture}[
		>={Stealth[round,sep]}
	]

	\begin{scope}[
		every node/.style={draw},
		task/.style={rectangle, color=#1, text=#1},
		choice/.style={diamond, node contents={}}
	]
		\node (A) [task=blue] at (0, 0) {A};
		\onslide<3->{\node (choiceStart) at (1, 0) [choice];}
		\node (B) [task=orange] at (2, 0.5) {B};
		\node (C) [task=orange] at (2, -0.5) {C};
		\node (D) [task=purple] at (3, -0.5) {D};
		\onslide<3->{\node (choiceEnd) at (4, 0) [choice];}
		\node (E) [task=green!50!black] at (5, 0) {E};
	\end{scope}

	\begin{onlyenv}<3->
		\begin{scope}[->]
			\draw (A) -> (choiceStart);
			\draw (choiceStart) |- (B);
			\draw (choiceStart) |- (C);
			\draw (C) -- (D);
			\draw (D) -| (choiceEnd);
			\draw (B) -| (choiceEnd);
			\draw (choiceEnd) -- (E);
		\end{scope}
	\end{onlyenv}
	
	\begin{onlyenv}<2->
		\begin{scope}[
			every node/.style={draw, circle},
			every fit/.style={ellipse, draw, inner sep=-1pt, densely dotted},
		]
			\begin{scope}[color=blue]
				\node[below=2em of A](a1){a1};
				\node[below=0 of a1](a2){a2};
				\node[fit=(a1)(a2)](a){};
				\draw[densely dotted] (A) -- (a);
			\end{scope}

			\begin{scope}[color=purple]
				\node[below=1.75em of D, xshift=2em](d1){d1};
				\node[fit=(d1)](d){};
				\draw[densely dotted] (D) -- (d);
			\end{scope}
		
			\begin{scope}[color=green!50!black]
				\node[below=1.25em of E](e1){e1};
				\node[below=0 of e1](e2){e2};
				\node[fit=(e1)(e2)](e){};
				\draw[densely dotted] (E) -- (e);
			\end{scope}

			\begin{scope}[color=orange]
				\node[below=1.75em of C, xshift=-1.5em](b1){b1};
				\node[below=0 of b1](b2){b2};
				\node[right=0 of b1, yshift=-1.4em](b3){b3};
				\node[fit=(b1)(b2)(b3), inner sep=-3pt, xshift=-3pt](b){};
				\draw[densely dotted] (C) -- (b);
				\draw[densely dotted] (B) -- (b);
			\end{scope}
		\end{scope}	
	\end{onlyenv}
\end{tikzpicture}
